Distribution:	CCux
Packager:  	Christian Metzen <metzench@ccux-linux.de>

Summary:   	A GNU collection of binary utilities.
Name:      	binutils
Version:   	2.21
Release:   	1
#Provides:  	libbfd-2.16.1.so libopcodes-2.16.1.so 
License:   	GNU/GPL
URL:	   	http://www.gnu.org/software/binutils/
Group:     	System/Base    
Source0:   	%{name}-%{version}.tar.bz2
Patch7: 	binutils-2.18.50.0.3-version.patch
BuildRoot: 	%{_tmppath}/%{name}-buildroot
BuildRequires: 	texinfo dejagnu gettext flex bison
BuildArch:	i686
Requires(pre): /sbin/install-info
#Automatically resolved build dependencies
BuildRequires: glibc-devel
BuildRequires: zlib-devel

%define _gnu %{nil}

%description
Binutils is a collection of binary utilities, including ar (for
creating, modifying and extracting from archives), as (a family of GNU
assemblers), gprof (for displaying call graph profile data), ld (the
GNU linker), nm (for listing symbols from object files), objcopy (for
copying and translating object files), objdump (for displaying
information from object files), ranlib (for generating an index for
the contents of an archive), size (for listing the section sizes of an
object or archive file), strings (for listing printable strings from
files), strip (for discarding symbols), and addr2line (for converting
addresses to file and line).

%package devel
Summary: 	BFD and opcodes static libraries and header files
Group: 		System/Libraries
Requires(pre): /sbin/install-info

%description devel
This package contains BFD and opcodes static libraries and associated
header files.  Only *.a libraries are included, because BFD doesn't
have a stable ABI.  Developers starting new projects are strongly encouraged
to consider using libelf instead of BFD.

%post
/sbin/ldconfig
/sbin/install-info --info-dir=%{_infodir} %{_infodir}/as.info.gz
/sbin/install-info --info-dir=%{_infodir} %{_infodir}/binutils.info.gz
/sbin/install-info --info-dir=%{_infodir} %{_infodir}/gprof.info.gz
/sbin/install-info --info-dir=%{_infodir} %{_infodir}/ld.info.gz
/sbin/install-info --info-dir=%{_infodir} %{_infodir}/standards.info.gz
/sbin/install-info --info-dir=%{_infodir} %{_infodir}/configure.info.gz

%preun
if [ $1 = 0 ] ;then
  /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/as.info.gz
  /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/binutils.info.gz
  /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/gprof.info.gz
  /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/ld.info.gz
  /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/standards.info.gz
  /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/configure.info.gz
fi

%postun -p /sbin/ldconfig

%post devel
/sbin/install-info --info-dir=%{_infodir} %{_infodir}/bfd.info.gz

%preun devel
if [ $1 = 0 ] ;then
  /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/bfd.info.gz
fi

%prep
%setup -q
%patch7 -p0 -b .version~

# LTP sucks
perl -pi -e 's/i\[3-7\]86/i[34567]86/g' */conf*
sed -i -e 's/%''{release}/%{release}/g' bfd/Makefile{.am,.in}
sed -i -e '/^libopcodes_la_\(DEPENDENCIES\|LIBADD\)/s,$, ../bfd/libbfd.la,' opcodes/Makefile.{am,in}
# Build libbfd.so and libopcodes.so with -Bsymbolic-functions if possible.
if gcc %{optflags} -v --help 2>&1 | grep -q -- -Bsymbolic-functions; then
sed -i -e 's/^libbfd_la_LDFLAGS = /&-Wl,-Bsymbolic-functions /' bfd/Makefile.{am,in}
sed -i -e 's/^libopcodes_la_LDFLAGS = /&-Wl,-Bsymbolic-functions /' opcodes/Makefile.{am,in}
fi
touch */configure

%build
rm -rf build-%{_target_platform}
mkdir build-%{_target_platform}
cd build-%{_target_platform}
CARGS=
%ifarch ia64
CARGS=--enable-targets=i386-linux
%endif
CC="gcc -L`pwd`/bfd/.libs/" CFLAGS="${CFLAGS:-%optflags}" ../configure \
  %{_target_platform} --prefix=%{_prefix} --exec-prefix=%{_exec_prefix} \
  --bindir=%{_bindir} --sbindir=%{_sbindir} --sysconfdir=%{_sysconfdir} \
  --datadir=%{_datadir} --includedir=%{_includedir} --libdir=%{_libdir} \
  --libexecdir=%{_libexecdir} --localstatedir=%{_localstatedir} \
  --sharedstatedir=%{_sharedstatedir} --mandir=%{_mandir} \
  --infodir=%{_infodir} --enable-shared $CARGS --disable-werror \
  --with-bugurl=http://ccux-linux.de/
make %{_smp_mflags} tooldir=%{_prefix} all
make %{_smp_mflags} tooldir=%{_prefix} info
make -k check < /dev/null > check.log 2>&1 || :
echo ====================TESTING=========================
cat check.log
echo ====================TESTING END=====================
cd ..


%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{_prefix}
cd build-%{_target_platform}
%makeinstall
make prefix=%{buildroot}%{_prefix} infodir=%{buildroot}%{_infodir} install-info
gzip -q9f %{buildroot}%{_infodir}/*.info*

# Rebuild libiberty.a with -fPIC
make -C libiberty clean
make CFLAGS="-fPIC $RPM_OPT_FLAGS" -C libiberty

install -m 644 libiberty/libiberty.a %{buildroot}%{_prefix}/%{_lib}
install -m 644 ../include/libiberty.h %{buildroot}%{_prefix}/include
# Remove Windows/Novell only man pages
rm -f %{buildroot}%{_mandir}/man1/{dlltool,nlmconv,windres}*

chmod +x %{buildroot}%{_prefix}/%{_lib}/lib*.so*

# Prevent programs to link against libbfd and libopcodes dynamically,
# they are changing far too often
rm -f %{buildroot}%{_prefix}/%{_lib}/lib{bfd,opcodes}.so

# Remove libtool files, which reference the .so libs
rm -f %{buildroot}%{_prefix}/%{_lib}/lib{bfd,opcodes}.la

# This one comes from gcc
rm -f %{buildroot}%{_infodir}/dir
rm -rf %{buildroot}%{_prefix}/%{_target_platform}

%ifarch %{ix86} x86_64 ppc ppc64 s390 s390x sparc sparc64
sed -i -e '/^#include "ansidecl.h"/{p;s~^.*$~#include <bits/wordsize.h>~;}' \
%ifarch %{ix86} x86_64
    -e 's/^#define BFD_ARCH_SIZE \(32\|64\) *$/#define BFD_ARCH_SIZE __WORDSIZE/' \
%endif
    -e 's/^#define BFD_DEFAULT_TARGET_SIZE \(32\|64\) *$/#define BFD_DEFAULT_TARGET_SIZE __WORDSIZE/' \
    -e 's/^#define BFD_HOST_64BIT_LONG [01] *$/#define BFD_HOST_64BIT_LONG (__WORDSIZE == 64)/' \
    -e 's/^#define BFD_HOST_64_BIT \(long \)\?long *$/#if __WORDSIZE == 32\
#define BFD_HOST_64_BIT long long\
#else\
#define BFD_HOST_64_BIT long\
#endif/' \
    -e 's/^#define BFD_HOST_U_64_BIT unsigned \(long \)\?long *$/#define BFD_HOST_U_64_BIT unsigned BFD_HOST_64_BIT/' \
    %{buildroot}%{_prefix}/include/bfd.h
%endif
touch -r ../bfd/bfd-in2.h %{buildroot}%{_prefix}/include/bfd.h

cd ..
%find_lang binutils
%find_lang opcodes
%find_lang bfd
%find_lang gas
%find_lang ld
%find_lang gprof
cat opcodes.lang >> binutils.lang
cat bfd.lang >> binutils.lang
cat gas.lang >> binutils.lang
cat ld.lang >> binutils.lang
cat gprof.lang >> binutils.lang


%files -f binutils.lang
%defattr(-,root,root)
%doc README
%{_bindir}/addr2line
%{_bindir}/ar
%{_bindir}/as
%{_bindir}/c++filt
%{_bindir}/elfedit
%{_bindir}/gprof
%{_bindir}/ld
%{_bindir}/ld.bfd
%{_bindir}/nm
%{_bindir}/objcopy
%{_bindir}/objdump
%{_bindir}/ranlib
%{_bindir}/readelf
%{_bindir}/size
%{_bindir}/strings
%{_bindir}/strip
%{_libdir}/libbfd-%{version}.so
%{_libdir}/libopcodes-%{version}.so
%{_infodir}/as.info.gz
%{_infodir}/binutils.info.gz
%{_infodir}/configure.info.gz
%{_infodir}/gprof.info.gz
%{_infodir}/ld.info.gz
%{_infodir}/standards.info.gz
%{_locale}/*/LC_MESSAGES/bfd.mo
%{_locale}/*/LC_MESSAGES/binutils.mo
%{_locale}/*/LC_MESSAGES/gas.mo
%{_locale}/*/LC_MESSAGES/gprof.mo
%{_locale}/*/LC_MESSAGES/ld.mo
%{_locale}/*/LC_MESSAGES/opcodes.mo
%{_mandir}/man1/addr2line.1.gz
%{_mandir}/man1/ar.1.gz
%{_mandir}/man1/as.1.gz
%{_mandir}/man1/c++filt.1.gz
%{_mandir}/man1/elfedit.1.gz
%{_mandir}/man1/gprof.1.gz
%{_mandir}/man1/ld.1.gz
%{_mandir}/man1/nm.1.gz
%{_mandir}/man1/objcopy.1.gz
%{_mandir}/man1/objdump.1.gz
%{_mandir}/man1/ranlib.1.gz
%{_mandir}/man1/readelf.1.gz
%{_mandir}/man1/size.1.gz
%{_mandir}/man1/strings.1.gz
%{_mandir}/man1/strip.1.gz
%{_mandir}/man1/windmc.1.gz

%files devel
%defattr(-,root,root)
%{_includedir}/ansidecl.h
%{_includedir}/bfd.h
%{_includedir}/bfdlink.h
%{_includedir}/dis-asm.h
%{_includedir}/libiberty.h
%{_includedir}/symcat.h
%{_libdir}/libbfd.a
%{_libdir}/libiberty.a
%{_libdir}/libopcodes.a
%{_infodir}/bfd.info.gz

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Thu Jan 20 2011 Karsten Brockmann <arcam@ccux-linux.de> 2.21-1
- Version update
* Thu Oct 22 2010 Karsten Brockmann <arcam@ccux-linux.de> 2.20.1-1
- Version update
* Thu Oct 22 2009 Christian Metzen <metzench@ccux-linux.de> 2.20-1
- Version update
* Thu Feb 05 2009 Christian Metzen <metzench@ccux-linux.de> 2.19.1-1
- Version update
* Mon Oct 27 2008 Christian Metzen <metzench@ccux-linux.de> 2.19-1
- Version update
* Sun Jun 08 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.18.50.0.7-1
- version update, glibc 2.8
* Sun Dec 23 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.18.50.0.3-1
- version update
* Wed Oct 03 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.18-1
- version update
* Sun Jan 07 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.17.50.0.8-3
- fixed symlinks
* Sun Jan 07 2007 Christian Metzen <metzench@ccux-linux.de> 2.17.50.0.8-2
- fixed compat symlinks
* Tue Jan 02 2007 Christian Metzen <metzench@ccux-linux.de> 2.17.50.0.8-1
- Version update , glibc2.5 buildchain
* Sun Jun 25 2006 Christian Metzen <metzench@ccux-linux.de> 2.17-1
- Version update
* Mon Jun 27 2005 Christian Metzen <metzench@ccux-linux.de> 2.16.1-2
- Tweaked Specfile, moved static files to devel Package
* Sun Jun 26 2005 Karsten Brockmann <brockmka@rz.fh-augsburg.de> 2.16.1-1
- Version Update, rebuilt spec
* Wed Aug 11 2004 Christian Metzen <metzench@ccux-linux.de> 2.15.90.0.1.1-1
- Initial Release
